#include <stdio.h>

extern FILE *outfile;
extern FILE *infile;

static unsigned char outbuf;
static int outcnt=0;

#define kBufSize        4096
#define kByteAlign      0x80
#define kWdPtrStart     0x80

static unsigned char    buf[kBufSize + 4];
static unsigned int             wdPtr = kWdPtrStart;
static int                              wdIndex = 0;
static int                              numInBuf = 0;

void setpos(long int Byte, unsigned int Bit){
	fseek ( infile , Byte , SEEK_SET );
	numInBuf=0;
	wdIndex=0;
	Get(Bit);
}
void getpos(long int *Byte, unsigned int *Bit){
	int count;
	unsigned int wdPtrSave;
	
	wdPtrSave = wdPtr;
	for(count=0;wdPtrSave != 0x80;count++)
		wdPtrSave<<=1;
	*Bit = count; // 0x80=0,0x40=1,0x20=2 usw
	
	*Byte = ftell(infile) - numInBuf + wdIndex;
}

int     Get_Bits(
	unsigned int    *destBuf,
	int                             numBits)
{
	int     index;

	*destBuf = 0;

	for (index = 0; index < numBits; index++)
	{
		/* refresh buffer if empty */
		if (wdIndex >= numInBuf)
		{
			/* read next kBufSize bytes */
			if ((numInBuf = fread(buf + 4, sizeof(unsigned char), kBufSize,
									infile)) <= 0)
				return(0);              /*      end of bit stream       */
		
			wdIndex = 0;
			wdPtr = kWdPtrStart;
		}

		/* get next bit */

		*destBuf = ((buf[wdIndex + 4] & wdPtr) ?
				(*destBuf << 1) | 0x01 : (*destBuf << 1));
		
		/* update bit pointer */
		if (wdPtr == 0x01)
		{
			wdIndex++;
			wdPtr = kWdPtrStart;
		}
		else
			wdPtr >>= 1;
	}
	return(1);
}

int Get(
	int numBits)
{
	unsigned int buf;

	if (! Get_Bits(&buf, numBits))
	{
		printf ("Error (Get - End Of File)\n");
		return(0);
	}

	return(buf);
}


int     Next_Bits(
	unsigned int    *destBuf,
	int                             numBits)
{
	unsigned int    wdPtrSave;
	int                             wdIndexSave;
	int                             index;

	/* save current buffer state */
	wdPtrSave = wdPtr;
	wdIndexSave = wdIndex;

	*destBuf = 0;

	for (index = 0; index < numBits; index++)
	{
		/* refresh buffer if empty */
		if (wdIndex >= numInBuf)
		{
			/* save last 4 bytes of old content */
			buf[0]=buf[numInBuf];
			buf[1]=buf[numInBuf + 1];
			buf[2]=buf[numInBuf + 2];
			buf[3]=buf[numInBuf + 3];

			wdIndexSave -= numInBuf;

			/* read next kBufSize bytes */
			if ((numInBuf = fread(buf + 4, sizeof(unsigned char), kBufSize,
									infile)) <= 0)
				return(0);              /*      end of bit stream       */
		
			wdIndex = 0;
			wdPtr = kWdPtrStart;
		}

		/* get next bit */

		*destBuf = ((buf[wdIndex + 4] & wdPtr) ?
				(*destBuf << 1) | 0x01 : (*destBuf << 1));

		/* update bit pointer */
		if (wdPtr == 0x01)
		{
			wdIndex++;
			wdPtr = kWdPtrStart;
		}
		else
			wdPtr >>= 1;
	}

	/* restore previous buffer state */
	wdPtr = wdPtrSave;
	wdIndex = wdIndexSave;

	return(1);
}

int Next_Start_Code()
{
	unsigned int buf;

	/* locate next start code */

	if (wdPtr != kByteAlign) /* not byte aligned */
	{
		/* skip stuffed zero bits */
		wdPtr=kByteAlign;
		wdIndex++;
	}

	if (!Next_Bits(&buf, 24))
		return(0); /* end of bitstream */

	while (buf != 0x000001)
	{
		if (!Get_Bits(&buf, 8)) /* zero byte */
			return(0);
		if (!Next_Bits(&buf, 24))
			return(0);
	}

	return(1);
}

void putbits(int data,int n)
{
  int i;
  unsigned int mask;

  mask = 1 << (n-1);

  for (i=0; i<n; i++)
  {
    outbuf <<= 1;

    if (data & mask)
      outbuf |= 1;

    mask >>= 1;
    outcnt++;

    if (outcnt==8)
    {
      putc(outbuf,outfile);
      outcnt = 0;
    }
  }
}

void putbuf()
{
  if (outcnt>0)
    putbits(0,8-outcnt);
}
